/*********************************************************
 oo	: ch8_AVLpointer.c
			: .  
				:    , AVL 
**********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch8_AVLpointer.h"


void dimiourgia_dentro(typos_deikti *riza)
{
 /*	
 *	o: 		
 *	: 		o  AVL AVL 
*/	
	*riza = NULL;
}

int	keno_dentro(typos_deikti riza)
{
 /*	
 *	o: 		o  AVL 
 *	:		 1     , o 0
*/
	return ( riza == NULL );
}

typos_deikti aristero_paidi(typos_deikti p)
{
 /*	
 *	o: 		 p      AVL 
 *	:		       p
*/
	if (!keno_dentro(p))
		return (p->apaidi);
	else
		return NULL;
}

typos_deikti dexi_paidi(typos_deikti p)
{
 /*	
 *	o: 		 p      AVL 
 *	:		       p
*/
	if (!keno_dentro(p))
		return (p->dpaidi);
	else
		return NULL;
}

void episkepsi(typos_deikti riza)
{
	riza->dedomena;
}

void endodiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o  AVL 
 *	:		     AVL . 
 *				 episkepsi    dedomena  
*/
	if (!keno_dentro(riza))
	{
		/*   */
		endodiataksi(riza->apaidi);

		/*  */
		episkepsi(riza);

		/*   */
		endodiataksi(riza->dpaidi);
	}
}

void prodiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o  AVL 
 *	:		     AVL . 
 *				 episkepsi    dedomena  
*/
	if (!keno_dentro(riza))
	{
		episkepsi(riza);
		endodiataksi(riza->apaidi);
		endodiataksi(riza->dpaidi);
	}
}

void metadiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o  AVL 
 *	:		     AVL . 
 *				 episkepsi    dedomena  
*/
	if (!keno_dentro(riza))
	{
		endodiataksi(riza->apaidi);
		endodiataksi(riza->dpaidi);
		episkepsi(riza);
	}
}

void dexia_peristrofi(typos_deikti *p)
{
	/*     */
}

void aristero_varos(typos_deikti *riza,int *ypsilotero)
{
	/*     */
}

void aristeri_peristrofi(typos_deikti *p)
{
 /*	
 *	o: 		 *p          
 *	:		   
*/
	typos_deikti prosoninos;
	if (keno_dentro(*p)) /*      */
		printf(" \n");
	else if (keno_dentro((*p)->dpaidi)) /*       */
		printf("  \n");
	else
	{
		prosoninos = (*p)->dpaidi;
		(*p)->dpaidi = prosoninos->apaidi;
		prosoninos->apaidi = *p;
		*p = prosoninos;
	}
}
void dexi_varos(typos_deikti *riza,int *ypsilotero)
{
 /*	
 *	:		     LL  LR    *riza
 *				            
 *				 *ypsilotero  1  0.         *riza 
 *				           
 *				 1  0.
*/
	typos_deikti x; /*     */
	typos_deikti w;

	x = (*riza)->dpaidi;
	switch (x->pi)
	{
	case DY:/* RR */
		(*riza)->pi = IY;
		x->pi = IY;
		aristeri_peristrofi(riza);
		*ypsilotero = FALSE;
		break;
	case IY:/*    */
		printf("\n");
		break;
	case AY:/* RL */
		w = x->apaidi;
		switch (w->pi)
		{
		case DY:
			(*riza)->pi = IY;
			x->pi = IY;
			break;
		case IY:
			(*riza)->pi = IY;
			x->pi = DY;
			break;
		case AY:
			(*riza)->pi = AY;
			x->pi = IY;
			break;
		}
		w->pi = IY;
		dexia_peristrofi(&x);
		/* x    w*/
		(*riza)->dpaidi = x;
		aristeri_peristrofi(riza);
		*ypsilotero = FALSE;
	}
}

void avl_eisagogi(typos_deikti *riza,typos_deikti prosorinos,typos_stoixeiou stoixeio,
				  int *ypsilotero)
{
 /*	
 *	o: 		o  AVL 
 *	:		     AVL . 
 *				 episkepsi    dedomena  
*/
	int ypsilotero_ypodentro; /*      */

	if (keno_dentro(*riza))
	{
		*riza = prosorinos;
		(*riza)->apaidi = NULL;
		(*riza)->dpaidi = NULL;
		(*riza)->pi = IY;
		*ypsilotero = TRUE;
	}
	else if (prosorinos->dedomena == (*riza)->dedomena)
		printf("     \n");
	else if (prosorinos->dedomena < (*riza)->dedomena)
	{			
		/*   */
		avl_eisagogi(&((*riza)->apaidi),prosorinos,stoixeio,&ypsilotero_ypodentro);
		if (ypsilotero_ypodentro)
		{
			switch((*riza)->pi)
			{
			case AY:
				aristero_varos(riza,ypsilotero);
				break;
			case IY:
				(*riza)->pi=AY;
				*ypsilotero = TRUE;
				break;
			case DY:
				(*riza)->pi = IY;
				*ypsilotero = FALSE;
				break;
			}
		}
	}
	else
	{
		avl_eisagogi(&((*riza)->dpaidi),prosorinos,stoixeio,&ypsilotero_ypodentro);
		if (ypsilotero_ypodentro)
		{
			switch((*riza)->pi)
			{
			case AY:
				(*riza)->pi = IY;
				*ypsilotero = FALSE;
				break;
			case IY:
				(*riza)->pi=DY;
				*ypsilotero = TRUE;
				break;
			case DY:
				dexi_varos(riza,ypsilotero);
				break;
			}
		}
	}
	*ypsilotero = FALSE;
}/*avl_eisagogi*/
